require "spec_helper"
require "asm/type"

ASM::Type.load_providers!

describe ASM::Provider::Configuration::Serverupdate do
  let(:logger) { stub(:debug => nil, :warn => nil, :info => nil) }
  let(:service) { SpecHelper.service_from_fixture("server_update.json") }
  let(:server_update_components) { service.components.select { |c| c.resource_ids.include?("asm::server_update") } }
  let(:type) { server_update_components[0].to_resource(nil, logger) }
  let(:provider) { type.provider }

  describe "#server_firmware_update_munger" do
    it "should handle server_firmware correctly" do
      expect(provider.server_firmware).to eq(nil) # Because the fixture json indicates "[]" which is empty list
    end
  end

  describe "#server_software_update_munger" do
    it "should handle server_software correctly" do
      server_software_list = JSON.parse(provider.server_software)
      expect(server_software_list.empty?).to eq(false)
      # Try setting to empty list and verify nil value
      provider.server_software = "[]"
      expect(provider.server_software).to eq(nil)
    end
  end

end
